Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 301)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 302)
@@ -97,6 +97,46 @@
         }
         #endregion
 
+        #region 初期時工事予算書画面表示
+        /// <summary>
+        /// 初期時工事予算書画面表示
+        /// </summary>
+        private void InitOtherForm()
+        {
+            try
+            {
+                int ProcessNo = (int)ClsExcute.ProcessExecuteNo.ConstructionBudget;
+                // フォームがあれば最前面へ
+                FrmConstructionBudget frm = (FrmConstructionBudget)ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle;
+                if (frm != null)
+                {
+                    frm.Activate();
+                    return;
+                }
+
+                // 工事予算書入力起動
+                frm = new FrmConstructionBudget();
+                ClsExcute.SubFormHandleList[ProcessNo].ProcessNo = s_CurrentProcessNo;
+                ClsExcute.SubFormHandleList[ProcessNo].SubFormHandle = (Form)frm;
+                frm.ConstructionCode = m_ConstructionCode;
+                frm.EditLock = m_EditLock;
+                frm.SubForm = true;
+                frm.ShowInTaskbar = true;
+
+                // クロースドハンドラをこちらで定義する
+                frm.FormClosed += new FormClosedEventHandler(FrmConstructionBudgetClosed);
+                frm.Show();
+
+                // フォームをずらす
+                frm.Location = CommonMotions.SetFormPosion(this.Location);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
         #region 行デフォルト色へ変更
         /// <summary>
         /// 行をデフォルト色にする
@@ -189,10 +229,10 @@
         private bool DispOrderEntryList()
         {
             FrmOrderEntryList frm = new FrmOrderEntryList();
+            this.Hide();
             try
             {
                 frm.OrderFrm = this;
-                this.Hide();
                 frm.ConstructionCode = m_ConstructionCode;
                 frm.ShowDialog();
 
@@ -203,8 +243,6 @@
                 m_OrderNo = CommonMotions.cnvInt(objRec[(int)FrmOrderEntryList.ReadDBColumn.OrderNo]);
                 //if (m_OrderNo == 0) m_OrderNo = -1;
 
-                this.Show();
-
                 return true;
             }
             catch (System.Exception ex)
@@ -214,6 +252,7 @@
             }
             finally
             {
+                this.Show();
                 frm.Dispose(); frm = null;
             }
         }
@@ -232,6 +271,7 @@
                 DispHeader();
 
                 // 注文書よりデータを取り込む
+                m_bCreateNewData = false;
                 if (!SetPurchaseOrderData())
                 {
                     // 工事詳細台帳よりデータを取り込む
@@ -239,8 +279,18 @@
 
                     // 承認データ受付番号セット
                     SetApprovalOrderNo();
+
+                    m_bCreateNewData = true;
                 }
 
+                // 新規時は削除ボタン非表示
+                if (m_bCreateNewData)
+                {
+                    btnPageDelete.Visible = false;
+                    btnDataDelete.Visible = false;
+                }
+                if (m_TabPageList.Count < 2) btnPageDelete.Visible = false;
+
                 // 申請・承認表示処理
                 InitApprovalDisplay();
 
@@ -436,46 +486,27 @@
                 // 工事台帳コードのセット
                 object[] ParentRec = (object[])m_DetailList[0];
                 strSQL.Clear();
-                strSQL.AppendFormat(" WHERE CONSTRUCTIONCODE = {0}",
-                                        CommonMotions.cnvInt(ParentRec[(int)FrmOrderEntryList.ReadDBColumn.ConstructionCode]));
+                strSQL.AppendFormat(" WHERE CONSTRUCTIONCODE = {0}"
+                                            , CommonMotions.cnvInt(ParentRec[(int)FrmOrderEntryList.ReadDBColumn.ConstructionCode]));
+                strSQL.AppendFormat(" AND SOURCECODE = {0}"
+                                            , CommonMotions.cnvInt(ParentRec[(int)FrmOrderEntryList.ReadDBColumn.SourceCode]));
+                strSQL.AppendFormat(" AND PurchaseOrderFlg = {0}", (int)ConstructionLedgerDetail.PurOrderFlgDef.NoCreate);
 
-                int SourceCode = 0;
-                int CompanyCode = 0;
-                int LineNo = 0;
-                int brkSourceCode = 0;
-                bool bFirstCode = true;
+                strSQL.Append(" AND (");
                 bool bFirstCompany = true;
                 foreach (object[] CurRec in m_DetailList)
                 {
-                    SourceCode = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.SourceCode]);
-                    CompanyCode = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.CompanyCode]);
-                    LineNo = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.LedgerLine]);
-                    // 工事番号のセット
-                    if (brkSourceCode != SourceCode)
-                    {
-                        if (bFirstCode)
-                        {
-                            strSQL.Append(" AND");
-                            bFirstCode = false;
-                        }
-                        else
-                        {
-                            strSQL.Append(")) OR");
-                        }
+                    int CompanyCode = CommonMotions.cnvInt(CurRec[(int)FrmOrderEntryList.ReadDBColumn.CompanyCode]);
 
-                        strSQL.AppendFormat(" (SOURCECODE = {0} AND (", SourceCode);
-
-                        brkSourceCode = SourceCode;
-                        bFirstCompany = true;
-                    }
                     // 会社番号のセット
                     if (!bFirstCompany) strSQL.Append(" OR");
 
-                    strSQL.AppendFormat(" (COMPANYCODE = {0} AND LINECOUNT = {1})", CompanyCode, LineNo);
+                    strSQL.AppendFormat(" COMPANYCODE = {0}", CompanyCode);
                     
                     bFirstCompany = false;
                 }
-                strSQL.Append(")) ORDER BY COMPANYCODE");
+                strSQL.Append(")");
+                strSQL.Append(" ORDER BY COMPANYCODE");
             }
             catch (System.Exception ex)
             {
@@ -658,7 +689,7 @@
                     CurRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = DetailRec.ConstructionCode;
                     TotalPrice += DetailRec.ExecutionAmount;
                     // 工事台帳行
-                    CurRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = DetailRec.LineCount;
+                    CurRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value = DetailRec.DetailCount;
                     // 予算書金額
                     CurRow.Cells[(int)DispDetailGridColumn.BudgetValue].Value = DetailRec.ExecutionAmount;
                     // 前回入力値金額
@@ -806,9 +837,9 @@
                     strSQL.Append(" Left Join constructionledgerdetail As B");
                     strSQL.Append("   On B.SourceCode = A.ConstructionCode");
                     strSQL.Append("   And B.ConstructionCode = A.SourceCode");
-                    strSQL.Append("   And B.LineCount = A.SourceLineCnt");
+                    strSQL.Append("   And B.DetailCount = A.SourceDetailCnt");
                     
-                    strSQL.Append(DetailDB.CreatePrimarykeyString(OrderRec.ConstructionCode, OrderRec.SeqNo, 0, 0, "A."));
+                    strSQL.Append(DetailDB.CreatePrimarykeyString(OrderRec.ConstructionCode, OrderRec.SeqNo, -1, 0, "A."));
                     strSQL.AppendFormat(" And A.GroupCount in ({0}, {1})", (int)PurchaseOrderDetail.GroupCountDef.Detail
                                                                         , (int)PurchaseOrderDetail.GroupCountDef.StatutoryWelfare);
 
@@ -996,7 +1027,7 @@
                     GetRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value = DetailRec.UnitPrice.ToString("#,#");	            // 単価
                     GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = DetailRec.OrdersLinePrice.ToString("#,0");       // 金額
                     GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value = DetailRec.SourceCode;                            // 元工事番号
-                    GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = DetailRec.SourceLineCnt;                         // 元台帳行番号
+                    GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value = DetailRec.SourceDetailCnt;                       // 元台帳明細番号
                     GetRow.Cells[(int)DispDetailGridColumn.DataType].Value = DetailRec.DataTypeFlag;                            // データタイプ
 
                     GetRow.Cells[(int)DispDetailGridColumn.BudgetValue].Value = CommonMotions.cnvInt(ObjRec[DetailFeildCnt]);   // 予算書金額
@@ -1686,9 +1717,9 @@
                         && CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.GroupNo].Value) == (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData)
                     {
                         // 元台帳行番号変更
-                        int nSourceLineCnt = 0;
-                        if (!CreateRowLedgerDetail(LDetailDB, DataTab, GetRow, ref nSourceLineCnt)) return false;
-                        GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value = nSourceLineCnt;
+                        int nSourceDetailCnt = 0;
+                        if (!CreateRowLedgerDetail(LDetailDB, DataTab, GetRow, ref nSourceDetailCnt)) return false;
+                        GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value = nSourceDetailCnt;
                     }
 
                     PurchaseOrderDetail DatailRec = new PurchaseOrderDetail();
@@ -1705,7 +1736,7 @@
                     DatailRec.UnitPrice = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value);	        // 単価
                     DatailRec.OrdersLinePrice = CommonMotions.cnvDouble(GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);  // 金額
                     DatailRec.SourceCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);          // 元工事番号
-                    DatailRec.SourceLineCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);       // 元台帳行番号
+                    DatailRec.SourceDetailCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value);     // 元台帳明細番号
                     DatailRec.DataTypeFlag = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.DataType].Value);          // データタイプ
 
                     // データ書込み
@@ -1767,7 +1798,7 @@
         private bool CreateRowLedgerDetail(IOConstructionLedgerDetail LDetailDB
                                             , PurchaseOrderInputPage DataTab
                                             , DataGridViewRow GetRow
-                                            , ref int nLineCnt)
+                                            , ref int nDetailCnt)
         {
             try
             {
@@ -1776,10 +1807,10 @@
                 // 台帳の追加行位置を取得する
                 int ConstrCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);
                 int GrpCnt = (int)FrmConstructionLedger.DataGroup.ConstructionCosts;
-                int LedgerLineCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);
+                int LedgerLineCnt = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value);
                 
                 strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt));
-                nLineCnt = LDetailDB.SelectMaxLineCount(strSQL.ToString(), false) + 1;
+                nDetailCnt = LDetailDB.SelectMaxDetailCount(strSQL.ToString(), false) + 1;
 
                 strSQL.Clear();
                 strSQL.Append("Insert INTO ConstructionLedgerDetail");
@@ -1786,18 +1817,18 @@
                 strSQL.Append(" SELECT");
                 strSQL.Append(" A.ConstructionCode");                       // 工事番号
                 strSQL.Append(", A.GroupCount");                            // グループ番号
-                strSQL.AppendFormat(", {0}", nLineCnt);                     // 行番号
+                strSQL.Append(", (A.LineCount + 1)");                       // 行番号
                 strSQL.Append(", A.ComponentCode");                         // 構成キー
                 strSQL.Append(", A.ItemCode");		                        // 工種キー
-                strSQL.Append(", A.FirstString");                           // 項目名称
-                strSQL.Append(", A.SecondString");                          // 工事内容
+                strSQL.Append(", ''");                                      // 項目名称
+                strSQL.Append(", ''");                                      // 工事内容
                 strSQL.Append(", A.CompanyType");                           // 協力会社コードタイプ
                 strSQL.AppendFormat(", {0}",DataTab.OrderCompanyCode);      // 協力会社コード
-                strSQL.Append(", B.CompanyName");                           // 協力会社名称
-                strSQL.Append(", A.EstimatePrice");                         // 予算（見積）金額
-                strSQL.Append(", A.ExecutionAmount");                       // 実行金額
-                strSQL.Append(", A.AmountConfigRate");                      // 金額構成率
-                strSQL.Append(", A.PaymentBurden");                         // 支払補填額
+                strSQL.AppendFormat(", '{0}'", DataTab.PageValueItem[(int)PageValue.SubConstractorName].Text);  // 協力会社名称
+                strSQL.Append(", 0");                                       // 予算（見積）金額
+                strSQL.Append(", 0");                                       // 実行金額
+                strSQL.Append(", 0");                                       // 金額構成率
+                strSQL.Append(", 0");                                       // 支払補填額
                 strSQL.Append(", A.FixDataFlg");                            // 固定データフラグ
                 strSQL.Append(", A.IndependentFlg");                        // 独立データフラグ
                 strSQL.Append(", A.FluctuationFlg");                        // 増減データフラグ
@@ -1808,12 +1839,13 @@
                 strSQL.Append(", A.JoinTitleFlg");                          // 工事名称タイトル
                 strSQL.Append(", A.SalaryOnRegist");                        // 登録時月額給与
                 strSQL.AppendFormat(", {0}", (int)ConstructionLedgerDetail.PurOrderFlgDef.Making);  // 注文書発行フラグ
+                strSQL.AppendFormat(", {0}", nDetailCnt);                     // 明細番号
                 strSQL.AppendFormat(", STR_TO_DATE('{0}','%Y/%m/%d %H:%i:%s')", DateTime.Now);
                 strSQL.AppendFormat(", STR_TO_DATE('{0}','%Y/%m/%d %H:%i:%s')", DateTime.Now);
                 strSQL.Append(" FROM ConstructionLedgerDetail As A");
-                strSQL.Append(" Left Join subcontractormaster As B On B.CompanyCode = A.CompanyCode");
 
-                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt, LedgerLineCnt));
+                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt, 0, "A."));
+                strSQL.AppendFormat(" And A.DetailCount = {0}", LedgerLineCnt);
 
                 if (!LDetailDB.ExecuteNonQuery(strSQL.ToString(), false))
                 {
@@ -1823,7 +1855,8 @@
 
                 // 変更前業者行更新
                 strSQL.Clear();
-                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt, LedgerLineCnt));
+                strSQL.Append(LDetailDB.CreatePrimarykeyString(ConstrCode, GrpCnt));
+                strSQL.AppendFormat(" And DetailCount = {0}", LedgerLineCnt);
                 if (!LDetailDB.UpdateFeild(strSQL.ToString()
                                             , (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg
                                             , (int)ConstructionLedgerDetail.PurOrderFlgDef.ChangeOld
@@ -1869,7 +1902,7 @@
                     // 金額
                     PriceVal = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
                     // 工事台帳行
-                    LedgerLine = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);
+                    LedgerLine = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value);
                     // 数量金額無は処理しない
                     if (QuantityVal == 0 && PriceVal == 0) continue;
                     if (LedgerLine == 0) continue;
@@ -1880,7 +1913,7 @@
                     strSQL.AppendFormat(" AND SOURCECODE = {0}", m_ConstructionCode);
                     strSQL.AppendFormat(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
                     strSQL.AppendFormat(" AND COMPANYCODE = {0}", DataTab.OrderCompanyCode);
-                    strSQL.AppendFormat(" AND LINECOUNT = {0}", LedgerLine);
+                    strSQL.AppendFormat(" AND DetailCount = {0}", LedgerLine);
                     if (!LDetailDB.UpdateFeild(strSQL.ToString()
                                                 , (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg
                                                 , (int)ConstructionLedgerDetail.PurOrderFlgDef.Making
@@ -1956,6 +1989,7 @@
                 LDetailDB.connect(); LDetailDB.beginTran();
 
                 StringBuilder strDel = new StringBuilder();
+                StringBuilder strUpdate = new StringBuilder();
                 for (int i = StartCnt; i < EndCnt; i++)
                 {
                     PurchaseOrderInputPage DataTab = m_TabPageList[i];
@@ -1989,12 +2023,13 @@
                             != (int)PurchaseOrderDetail.GroupCountDef.Detail) continue;
 
                         SourceCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);
-                        SourceLine = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);
-                        if(!LDetailDB.UpdateFeild(SourceCode,
+                        SourceLine = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value);
+                        strUpdate.Clear();
+                        strUpdate.AppendFormat(LDetailDB.CreatePrimarykeyString(SourceCode, (int)FrmConstructionLedger.DataGroup.ConstructionCosts));
+                        strUpdate.AppendFormat(" And DetailCount = {0}", SourceLine);
+                        if (!LDetailDB.UpdateFeild(strUpdate.ToString(),
                                                     (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg,
                                                     (int)ConstructionLedgerDetail.PurOrderFlgDef.NoCreate,
-                                                    (int)FrmConstructionLedger.DataGroup.ConstructionCosts,
-                                                    SourceLine,
                                                     false))
                         {
                             OrderDB.rollback();
@@ -2029,12 +2064,135 @@
         }
         #endregion
 
+        #region 行削除処理
+        /// <summary>
+        /// 行削除ボタン押下後の削除処理
+        /// </summary>
+        /// <returns></returns>
+        private bool LineRemoveProcess()
+        {
+            IOPurchaseOrderDetail PDetailDB = new IOPurchaseOrderDetail();
+            IOConstructionLedgerDetail LDetailDB = new IOConstructionLedgerDetail();
+
+            // タブカウント取得
+            int TabCnt = TabCollections.SelectedIndex;
+            PurchaseOrderInputPage DataTab = m_TabPageList[TabCnt];
+            DataGridView dgv = DataTab.Group1DataGridView;
+            DataGridViewRow GetRow = dgv.CurrentRow;
+            Color[] wrkSave = new Color[2];
+            bool bLineDel = false;
+            try
+            {
+                // 通常データ以外は処理しない
+                if (CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.DataType].Value)
+                    != (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData) return true;
+                if (CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value) < 1) return true;
+
+                wrkSave[0] = GetRow.DefaultCellStyle.BackColor;
+                wrkSave[1] = GetRow.DefaultCellStyle.ForeColor;
+                GetRow.DefaultCellStyle.BackColor = Color.Blue;
+                GetRow.DefaultCellStyle.ForeColor = Color.White;
+
+                if (MessageBox.Show("選択中の行を削除します。", "行削除確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
+
+
+                if (MessageBox.Show("「はい(Y)」を選択すると選択されている行は削除されます！！\n本当によろしいですか？", "削除確認"
+                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
+
+                // 行削除
+                int nRemoveNo = GetRow.Index;
+                dgv.Rows.RemoveAt(nRemoveNo);
+
+                bLineDel = true;
+
+                // 明細グリッド合計計算処理
+                CalculateDetailGridTotal(dgv);
+
+                // 新規データはデータを処理しない
+                if (m_bCreateNewData) return true;
+
+                int SeqCnt = DataTab.SeqNo;
+
+                PDetailDB.connect(); PDetailDB.beginTran();
+                LDetailDB.connect(); LDetailDB.beginTran();
+
+                StringBuilder strDel = new StringBuilder();
+                strDel.Append(PDetailDB.CreatePrimarykeyString(m_ConstructionCode, SeqCnt, (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData));
+                if (!PDetailDB.DeleteAction(strDel.ToString(), false))
+                {
+                    PDetailDB.rollback();
+                    MessageBox.Show("注文書明細データ削除に失敗しました。", "削除処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                // 台帳の注文書作成フラグをOFFにする
+                // 明細行のみを対象とする
+                if (CommonMotions.chkObjectIsNull(GetRow.Cells[(int)DispDetailGridColumn.GroupNo].Value)) return false;
+                if (CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.GroupNo].Value)
+                    != (int)PurchaseOrderDetail.GroupCountDef.Detail) return false;
+
+                int SourceCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);
+                int SourceLine = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.LedgerDetailNo].Value);
+                StringBuilder strUpdate = new StringBuilder();
+                strUpdate.AppendFormat(LDetailDB.CreatePrimarykeyString(SourceCode, (int)FrmConstructionLedger.DataGroup.ConstructionCosts));
+                strUpdate.AppendFormat(" And DetailCount = {0}", SourceLine);
+                if (!LDetailDB.UpdateFeild(strUpdate.ToString(),
+                                            (int)IOConstructionLedgerDetail.TableColumn.PurchaseOrderFlg,
+                                            (int)ConstructionLedgerDetail.PurOrderFlgDef.NoCreate,
+                                            false))
+                {
+                    PDetailDB.rollback();
+                    LDetailDB.rollback();
+                    MessageBox.Show("工事台帳データ注文書フラグ更新に失敗しました。", "削除処理エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                PDetailDB.commit();
+                LDetailDB.commit();
+
+                // 残った明細行を確認する
+                int nDataCnt = dgv.Rows.Cast<DataGridViewRow>().Where(x => CommonMotions.cnvInt(x.Cells[(int)DispDetailGridColumn.DataType].Value)
+                                                                                == (int)PurchaseOrderDetail.DataTypeFlagDef.CommonData
+                                                                        && CommonMotions.cnvInt(x.Cells[(int)DispDetailGridColumn.PriceValue].Value) != 0)
+                                                                .Count();
+                if (nDataCnt < 1)
+                {
+                    bool bSave = m_bChengeAns;
+                    m_bChengeAns = false;
+                    
+                    // ページ削除
+                    PageRemoveProcess(false);
+                    
+                    m_bChengeAns = bSave;
+                }
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                if (!bLineDel)
+                {
+                    GetRow.DefaultCellStyle.BackColor = wrkSave[0];
+                    GetRow.DefaultCellStyle.ForeColor = wrkSave[1];
+                }
+
+                PDetailDB.close(); PDetailDB = null;
+                LDetailDB.close(); LDetailDB = null;
+            }
+        }
+        #endregion
+
         #region ページ削除処理
         /// <summary>
         /// ページ削除ボタン押下後の削除処理
         /// </summary>
         /// <returns></returns>
-        private bool PageRemoveProcess()
+        private bool PageRemoveProcess(bool bDispMsg = true)
         {
             try
             {
@@ -2044,18 +2202,22 @@
                     if (MessageBox.Show("データの変更がありますがページ削除を実行してもよろしいですか。", "ページ削除実行確認"
                             , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
                 }
-                
-                if (MessageBox.Show("選択中のページを削除します。", "ページ削除確認"
-                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
 
-                if (MessageBox.Show("「はい(Y)」を選択すると表示されている\n協力業者の注文書データは削除されます！！\n本当によろしいですか？", "削除確認"
-                        , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
+                if (bDispMsg)
+                {
+                    if (MessageBox.Show("選択中のページを削除します。", "ページ削除確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
 
+                    if (MessageBox.Show("「はい(Y)」を選択すると表示されている\n協力業者の注文書データは削除されます！！\n本当によろしいですか？", "削除確認"
+                            , MessageBoxButtons.YesNo, MessageBoxIcon.Information) != DialogResult.Yes) return true;
+                }
+
                 // タブカウント取得
                 int TabCnt = TabCollections.SelectedIndex;
 
                 // データ削除
-                if (!DataRemoveProcess(false, TabCnt, (TabCnt + 1))) return false;
+                if (!m_bCreateNewData)
+                    if (!DataRemoveProcess(false, TabCnt, (TabCnt + 1))) return false;
 
                 // タブを削除する
                 TabCollections.TabPages.RemoveAt(TabCnt);
@@ -2063,6 +2225,13 @@
                 // 配列から削除
                 m_TabPageList.RemoveAt(TabCnt);
 
+                // ページが無くなった場合は処理終了
+                if (m_TabPageList.Count < 1)
+                {
+                    m_bChengeAns = false;
+                    this.Close();
+                }
+
                 return true;
             }
             catch (System.Exception ex)
